
;@desc : Returns the current language of the system
ProcedureDLL.s System_GetCurrentLanguage()
  ;@author : Progi1984
  Protected sLanguage.s
  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Linux ;{
      sLanguage = GetEnvironmentVariable("LANG")
    ;}
    CompilerCase #PB_OS_MacOS ;{
      ; http://developer.apple.com/documentation/MacOSX/Conceptual/BPInternational/Articles/ChoosingLocalizations.html#//apple_ref/doc/uid/20002397-SW4
    ;}
    CompilerCase #PB_OS_Windows ;{
      #LOCALE_SISO639LANGNAME = 89
      #LOCALE_SISO3166CTRYNAME = 90

      Protected sBuffer.s
      Protected lBufferLen.l = 1000
      sBuffer=Space(lBufferLen)
      Result=GetLocaleInfo_(#LOCALE_SYSTEM_DEFAULT, #LOCALE_SISO639LANGNAME, sBuffer, lBufferLen)
      ;http://www.loc.gov/standards/iso639-2/php/code_list.php
      ;http://fr.wikipedia.org/wiki/Liste_des_codes_ISO_639-1
      ;If Result > 0 ; ok
        sLanguage = sBuffer
     
;       sBuffer=Space(lBufferLen)
;       GetLocaleInfo_(#LOCALE_SYSTEM_DEFAULT, #LOCALE_SISO3166CTRYNAME, sBuffer, lBufferLen)
;       sLanguage + "." + sBuffer
    ;} 
  CompilerEndSelect
  ProcedureReturn sLanguage
EndProcedure
Debug System_GetCurrentLanguage()

ProcedureDLL.s GetUserLanguage() ; Retrieves the Language of the user
  ;droopylib
  LangInf= GetUserDefaultLCID_()
  langId_main=LangInf&$FF
  langId_sub=(LangInf&$FF>>8)&$FF
  
  lan$="":sub$=""
  
  Select langId_main
    Case $00: lan$="Neutral"
      Select langId_sub
        Case $01: sub$="Default"
        Case $02: sub$="System Default"
      EndSelect
    Case $01: lan$="Arabic"
      Select langId_sub
        Case $01: sub$="Arabia"
        Case $02: sub$="Iraq"
        Case $03: sub$="Egypt" 
        Case $04: sub$="Libya" 
        Case $05: sub$="Algeria" 
        Case $06: sub$="Morocco" 
        Case $07: sub$="Tunisia" 
        Case $08: sub$="Oman" 
        Case $09: sub$="Yemen" 
        Case $10: sub$="Syria" 
        Case $11: sub$="Jordan" 
        Case $12: sub$="Lebanon" 
        Case $13: sub$="Kuwait" 
        Case $14: sub$="U.A.E." 
        Case $15: sub$="Bahrain"
        Case $16: sub$="Qatar"
      EndSelect
    Case $02: lan$="Bulgarian"
    Case $03: lan$="Catalan"  
    Case $04: lan$="Chinese"
      Select langId_sub
        Case $01: sub$="Traditional"
        Case $02: sub$="Simplified"
        Case $03: sub$="Hong Kong SAR, PRC"
        Case $04: sub$="Singapore"
        Case $05: sub$="Macau"
      EndSelect
    Case $05: lan$="Czech"
    Case $06: lan$="Danish" 
    Case $07: lan$="German" 
      Select langId_sub
        Case $01: sub$=""
        Case $02: sub$="Swiss"
        Case $03: sub$="Austrian"
        Case $04: sub$="Luxembourg"
        Case $05: sub$="Liechtenstein"
      EndSelect
    Case $08: lan$="Greek" 
    Case $09: lan$="English"
      Select langId_sub
        Case $01: sub$="US"
        Case $02: sub$="UK"
        Case $03: sub$="Australian"
        Case $04: sub$="Canadian"
        Case $05: sub$="New Zealand"
        Case $06: sub$="Ireland"
        Case $07: sub$="South Africa"
        Case $08: sub$="Jamaica"
        Case $09: sub$="Caribbean"
        Case $0A: sub$="Belize"
        Case $0B: sub$="Trinidad" 
        Case $0C: sub$="Zimbabwe"
        Case $0D: sub$="Philippines"
      EndSelect
    Case $0A: lan$="Spanish"
      Select langId_sub
        Case $01: sub$="Castilian" 
        Case $02: sub$="Mexican" 
        Case $03: sub$="Modern"
        Case $04: sub$="Guatemala"
        Case $05: sub$="Costa Rica"
        Case $06: sub$="Panama"
        Case $07: sub$="Dominican Republic"
        Case $08: sub$="Venezuela"
        Case $09: sub$="Colombia"
        Case $0A: sub$="Peru"
        Case $0B: sub$="Argentina"
        Case $0C: sub$="Ecuador"
        Case $0D: sub$="Chile"
        Case $0E: sub$="Uruguay"
        Case $0F: sub$="Paraguay" 
        Case $10: sub$="Bolivia"
        Case $11: sub$="El Salvador"
        Case $12: sub$="Honduras"
        Case $13: sub$="Nicaragua"
        Case $14: sub$="Puerto Rico"
      EndSelect
    Case $0B: lan$="Finnish" 
    Case $0C: lan$="French" 
      Select langId_sub
        Case $01: sub$="" 
        Case $02: sub$="Belgian"
        Case $03: sub$="Canadian"
        Case $04: sub$="Swiss"
        Case $05: sub$="Luxembourg"
        Case $06: sub$="Monaco"
      EndSelect
    Case $0D: lan$="Hebrew" 
    Case $0E: lan$="Hungarian" 
    Case $0F: lan$="Icelandic" 
    Case $10: lan$="Italian"
      If langId_sub=$02: sub$="Swiss" :EndIf
    Case $11: lan$="Japanese" 
    Case $12: lan$="Korean" 
    Case $13: lan$="Dutch"
      If langId_sub=$02: sub$="Belgian" :EndIf
    Case $14: lan$="Norwegian"
      Select langId_sub
        Case $01: sub$="Norwegian"
        Case $02: sub$="Nynorsk"
      EndSelect
    Case $15: lan$="Polish" 
    Case $16: lan$="Portuguese"
      If langId_sub=$02: sub$="Brazilian" :EndIf
    Case $18: lan$="Romanian" 
    Case $19: lan$="Russian" 
    Case $1A: lan$="Croatian" 
    Case $1A: lan$="Serbian"
      Select langId_sub
        Case $02: sub$="Latin"
        Case $03: sub$="Cyrillic"
      EndSelect
    Case $1B: lan$="Slovak" 
    Case $1C: lan$="Albanian" 
    Case $1D: lan$="Swedish"
      If langId_sub=$02: sub$="Finland" :EndIf  
    Case $1E: lan$="Thai" 
    Case $1F: lan$="Turkish"  
    Case $20: lan$="Urdu"
      Select langId_sub
        Case $01: sub$="Pakistan"
        Case $02: sub$="India"
      EndSelect
    Case $21: lan$="Indonesian" 
    Case $22: lan$="Ukrainian" 
    Case $23: lan$="Belarusian" 
    Case $24: lan$="Slovenian" 
    Case $25: lan$="Estonian" 
    Case $26: lan$="Latvian" 
    Case $27: lan$="Lithuanian"
      If langId_sub: sub$="Classic" :EndIf
    Case $29: lan$="Farsi" 
    Case $2A: lan$="Vietnamese" 
    Case $2B: lan$="Armenian" 
    Case $2C: lan$="Azeri"
      Select langId_sub
        Case $01: sub$="Latin"
        Case $02: sub$="Cyrillic"
      EndSelect
    Case $2D: lan$="Basque" 
    Case $2F: lan$="Macedonian" 
    Case $36: lan$="Afrikaans" 
    Case $37: lan$="Georgian" 
    Case $38: lan$="Faeroese" 
    Case $39: lan$="Hindi" 
    Case $3E: lan$="Malay"
      Select langId_sub
        Case $01: sub$="Malaysia"
        Case $02: sub$="Brunei Darassalam"
      EndSelect
    Case $3F: lan$="Kazak" 
    Case $41: lan$="Swahili" 
    Case $43: lan$="Uzbek"
      Select langId_sub
        Case $01: sub$="Latin"
        Case $02: sub$="Cyrillic"
      EndSelect 
    Case $44: lan$="Tatar" 
    Case $45: lan$="Bengali" 
    Case $46: lan$="Punjabi" 
    Case $47: lan$="Gujarati" 
    Case $48: lan$="Oriya" 
    Case $49: lan$="Tamil" 
    Case $4A: lan$="Telugu" 
    Case $4B: lan$="Kannada" 
    Case $4C: lan$="Malayalam" 
    Case $4D: lan$="Assamese" 
    Case $4E: lan$="Marathi" 
    Case $4F: lan$="Sanskrit" 
    Case $57: lan$="Konkani" 
    Case $58: lan$="Manipuri" 
    Case $59: lan$="Sindhi" 
    Case $60: lan$="Kashmiri"
      If langId_sub=$02 : sub$="India" : EndIf
    Case $61: lan$="Nepali"
      If langId_sub=$02 : sub$="India" : EndIf
  EndSelect
  
  ProcedureReturn  lan$
EndProcedure
;Debug GetUserLanguage()
ProcedureDLL GetLanguage(wish) ; Returns the default primary language identifier ( 0 system / 1 User )
  ;https://msdn.microsoft.com/en-us/library/windows/desktop/dd318693%28v=vs.85%29.aspx
  ;9= english
  ;12=french
  If wish
    ProcedureReturn GetUserDefaultLangID_() & 511
  Else
    ProcedureReturn GetSystemDefaultLangID_() & 511
  EndIf
EndProcedure
; Debug GetLanguage(0)
; Debug GetLanguage(1)
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 3
; Folding = P-
; EnableXP