;atomo
Enumeration
		#MouseEvent_EventType_LeftClick
		#MouseEvent_EventType_LeftDoubleClick
		#MouseEvent_EventType_LeftButtonPushed
		#MouseEvent_EventType_LeftButtonReleased
		#MouseEvent_EventType_RightClick
		#MouseEvent_EventType_RightDoubleClick
		#MouseEvent_EventType_RightButtonPushed
		#MouseEvent_EventType_RightButtonReleased
		#MouseEvent_EventType_Enter
		#MouseEvent_EventType_Exit
		#MouseEvent_EventType_Drag
		#MouseEvent_EventType_Move
EndEnumeration

Structure MouseEvent_Gadget
		Gadget.i
		GadgetID.i
		MouseHover.b
		Drag.b
		LeftButtonPushed.b
		LeftButtonTimestamp.i
		RightButtonPushed.b
		RightButtonTimestamp.i
EndStructure

Structure MouseEvent_EventStack
		Gadget.i
		EventType.b
EndStructure

Threaded NewList MouseEvent_Gadget.MouseEvent_Gadget()
Threaded NewList MouseEvent_EventStack.MouseEvent_EventStack()

Threaded MouseEvent_MouseX, MouseEvent_MouseY
Threaded MouseEventGadget, MouseEventType

ProcedureDLL isMouseButton(Button)
		CompilerIf #PB_Compiler_OS = #PB_OS_Windows
				If GetAsyncKeyState_(Button) & 32768
						ProcedureReturn #True
				EndIf
		CompilerEndIf
EndProcedure

ProcedureDLL isMouseMoved()
		MouseX = DesktopMouseX() : MouseY = DesktopMouseY()
		If MouseX <> MouseEvent_MouseX Or MouseY <> MouseEvent_MouseY
				MouseEvent_MouseX = MouseX : MouseEvent_MouseY = MouseY
				ProcedureReturn #True
		EndIf
EndProcedure

ProcedureDLL GetObjectFromPosition(x, y)
		CompilerIf #PB_Compiler_OS = #PB_OS_Windows
				ProcedureReturn WindowFromPoint_(y<<32|x)
		CompilerEndIf
EndProcedure

ProcedureDLL SendMouseEvent(Gadget, EventType)
		LastElement(MouseEvent_EventStack())
		AddElement(MouseEvent_EventStack())
		MouseEvent_EventStack()\Gadget = Gadget
		MouseEvent_EventStack()\EventType = EventType
EndProcedure

ProcedureDLL MouseEvent()
		Object = GetObjectFromPosition(DesktopMouseX(), DesktopMouseY())
		isMouseMoved = isMouseMoved()
		
		ForEach MouseEvent_Gadget() 
				;{ Hover
				If MouseEvent_Gadget()\GadgetID = Object
						If MouseEvent_Gadget()\MouseHover = #False
								SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_Enter)
								MouseEvent_Gadget()\MouseHover = #True
								If MouseEvent_Gadget()\LeftButtonPushed = #False
										MouseEvent_Gadget()\LeftButtonPushed = -1
								EndIf
								If MouseEvent_Gadget()\RightButtonPushed = #False
										MouseEvent_Gadget()\RightButtonPushed = -1
								EndIf
						EndIf
						Else
						If MouseEvent_Gadget()\MouseHover = #True
								SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_Exit)
								MouseEvent_Gadget()\MouseHover = #False
						EndIf
				EndIf
				;}
				;{ Left Button
				If isMouseButton(#PB_MouseButton_Left) = #True
						If MouseEvent_Gadget()\MouseHover = #True
								If MouseEvent_Gadget()\LeftButtonPushed = #False
										SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_LeftButtonPushed)
										MouseEvent_Gadget()\LeftButtonPushed = #True
								EndIf
						EndIf
						Else
						If MouseEvent_Gadget()\LeftButtonPushed = #True
								SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_LeftButtonReleased)
								If MouseEvent_Gadget()\MouseHover = #True And MouseEvent_Gadget()\Drag = #False
										If ElapsedMilliseconds()-MouseEvent_Gadget()\LeftButtonTimestamp <= 500
												SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_LeftDoubleClick)
												MouseEvent_Gadget()\LeftButtonTimestamp = 0
												Else
												SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_LeftClick)
												MouseEvent_Gadget()\LeftButtonTimestamp = ElapsedMilliseconds()
										EndIf
								EndIf
								MouseEvent_Gadget()\LeftButtonPushed = #False
								MouseEvent_Gadget()\Drag = #False
								ElseIf MouseEvent_Gadget()\LeftButtonPushed = -1
								MouseEvent_Gadget()\LeftButtonPushed = #False
						EndIf
				EndIf
				;} 
				;{ Right Button
				If isMouseButton(#PB_MouseButton_Right) = #True
						If MouseEvent_Gadget()\MouseHover = #True
								If MouseEvent_Gadget()\RightButtonPushed = #False
										SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_RightButtonPushed)
										MouseEvent_Gadget()\RightButtonPushed = #True
								EndIf
						EndIf
						Else
						If MouseEvent_Gadget()\RightButtonPushed = #True
								SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_RightButtonReleased)
								If MouseEvent_Gadget()\MouseHover = #True
										If ElapsedMilliseconds()-MouseEvent_Gadget()\RightButtonTimestamp <= 500
												SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_RightDoubleClick)
												MouseEvent_Gadget()\RightButtonTimestamp = 0
												Else
												SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_RightClick)
												MouseEvent_Gadget()\RightButtonTimestamp = ElapsedMilliseconds()
										EndIf
								EndIf
								MouseEvent_Gadget()\RightButtonPushed = #False
								ElseIf MouseEvent_Gadget()\RightButtonPushed = -1
								MouseEvent_Gadget()\RightButtonPushed = #False
						EndIf
				EndIf
				;} 
				;{ Movement
				If isMouseMoved = #True
						If MouseEvent_Gadget()\LeftButtonPushed = #True
								SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_Drag)
								MouseEvent_Gadget()\Drag = #True
								Else
								If MouseEvent_Gadget()\MouseHover = #True
										SendMouseEvent(MouseEvent_Gadget()\Gadget, #MouseEvent_EventType_Move)
								EndIf
						EndIf
				EndIf
				;}
		Next
		
		;Get Event
		If ListSize(MouseEvent_EventStack())
				FirstElement(MouseEvent_EventStack())
				MouseEventGadget = MouseEvent_EventStack()\Gadget
				MouseEventType = MouseEvent_EventStack()\EventType
				DeleteElement(MouseEvent_EventStack())
				ProcedureReturn #True
		EndIf
EndProcedure

ProcedureDLL MouseEventGadget()
		ProcedureReturn MouseEventGadget
EndProcedure

ProcedureDLL isMouseEventGadget(Gadget)
		ForEach MouseEvent_Gadget()
				If MouseEvent_Gadget()\Gadget = Gadget
						ProcedureReturn #True
				EndIf
		Next
EndProcedure

ProcedureDLL MouseEventType()
		ProcedureReturn MouseEventType
EndProcedure

ProcedureDLL AddMouseEventGadget(Gadget)
		If isMouseEventGadget(Gadget) = #False
				AddElement(MouseEvent_Gadget())
				MouseEvent_Gadget()\Gadget = Gadget
				MouseEvent_Gadget()\GadgetID = GadgetID(Gadget)
		EndIf
EndProcedure

ProcedureDLL RemoveMouseEventGadget(Gadget)
		ForEach MouseEvent_Gadget()
				If MouseEvent_Gadget()\Gadget = Gadget
						DeleteElement(MouseEvent_Gadget())
						Break
				EndIf
		Next
EndProcedure


; Exemple d'utilisation :
Window = OpenWindow(#PB_Any, 0, 0, 300, 300, "Window", #PB_Window_MinimizeGadget|#PB_Window_TitleBar|#PB_Window_ScreenCentered)
If Window
		
		ContainerGadget = ContainerGadget(#PB_Any, 50, 50, 200, 50, #PB_Container_Flat)
		SetGadgetColor(ContainerGadget, #PB_Gadget_BackColor, #White)
		AddMouseEventGadget(ContainerGadget)
		CloseGadgetList()
		textegadget=TextGadget(#PB_Any,10,200,30,30,"texte",#SS_NOTIFY)
		AddMouseEventGadget(ContainerGadget)
		
		Repeat
				Event = WaitWindowEvent(1)
				MouseEvent = MouseEvent()
				If MouseEvent
						If MouseEventGadget() = ContainerGadget
								Select MouseEventType()
										Case #MouseEvent_EventType_LeftClick
										Debug "LeftClick"
										Case #MouseEvent_EventType_LeftDoubleClick
										Debug "LeftDoubleClick"
										Case #MouseEvent_EventType_LeftButtonPushed
										Debug "LeftButtonPushed"
										Case #MouseEvent_EventType_LeftButtonReleased
										Debug "LeftButtonReleased"
										Case #MouseEvent_EventType_RightClick
										Debug "RightClick"
										Case #MouseEvent_EventType_RightDoubleClick
										Debug "RightDoubleClick"
										Case #MouseEvent_EventType_RightButtonPushed
										Debug "RightButtonPushed"
										Case #MouseEvent_EventType_RightButtonReleased
										Debug "RightButtonReleased"
										Case #MouseEvent_EventType_Enter
										Debug "Enter"
										Case #MouseEvent_EventType_Exit
										Debug "Exit"
										Case #MouseEvent_EventType_Drag
										Debug "Drag"
										Case #MouseEvent_EventType_Move
										Debug "Move"
								EndSelect
						EndIf
				EndIf
		Until event = #PB_Event_CloseWindow
EndIf
; Epb


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 2
; Folding = ---
; EnableXP