﻿;http://www.purebasic.fr/french/viewtopic.php?f=8&t=14254&view=next

; Remarque : TODO reste à gérer le cas où la souris est en dehors de la fenêtre

Structure MSLLHOOKSTRUCT
  pt.Point
  mouseData.l
  flags.l
  time.l
  ; align.l pour x64
  *dwExtraInfo
EndStructure


#Main = 10

Global HHOOKMouse.i
Global hWinMain

;Global LastLeftButtonClickTime ; doubleclic

Procedure LowLevelMouseProc(nCode.l, wParam.i, lParam.i)
  Protected *Pointer.MSLLHOOKSTRUCT, ID.l, Handle.i
  Static LastLeftButtonClickTime, MemID.l, WasOnGadget.l = 0, WasOnWindow.l = 0
  
  
  If nCode < 0  ; préconisé par microsoft
    ProcedureReturn CallNextHookEx_(HHOOKMouse, nCode, wParam, lParam); 
  EndIf
  
  
  If nCode = #HC_ACTION
    *Pointer = lParam
    
    ; Horodatage de l'évènement (peut être static ou protected...)
    ;Chrono = *Pointer\time
    ;Debug Chrono
    
    ; Position de la souris dans l'écran
    ;Debug "MouseX="+Str(*Pointer\pt\x)+ " MouseY="+Str(*Pointer\pt\y)
    
    ;Position de la souris dans la fenêtre #Main 
    ScreenToClient_(WindowID(#Main), @*Pointer\pt)
    ;Debug "MouseX="+Str(*Pointer\pt\x)+ " MouseY="+Str(*Pointer\pt\y)
    
    
    ; Quel gadget ?
    Handle = RealChildWindowFromPoint_(WindowID(#Main), *Pointer\pt\x + *Pointer\pt\y << 32)
    ;Debug Handle
    
    ;     If Handle=0 ; Souris en dehors de la fenêtre
    ;       WasOnWindow=1
    ;     EndIf
    
    
    If handle=hWinMain ; Souris sur la fenêtre mais pas sur un gadget
     ;Debug "window #Main"
      Gadget = #False
      
    Else ; Souris sur un gadget
      Gadget=#True
      ID = GetDlgCtrlID_(Handle)
    EndIf
    
    
    Select wParam 
      Case #WM_MOUSEMOVE
        ;Debug "WM_MOUSEMOVE" 
        
        If Gadget = #False ; Sur la fenêtre
        ;Debug "Over Windows #Main"
          
          If WasOnGadget = 1
            Debug "EXIT Gadget ID = " + Str(MemID)
          EndIf
          WasOnGadget=0 
        Else               ; Sur un gadget
          
          
          If WasOnGadget=0 Or MemID<>ID  
            Debug "ENTER Gadget ID = " + Str(ID)
            WasOnGadget=1
            MemID = ID
          Else
            ;Debug "Over Gadget ID = " + Str(ID) 
          EndIf 
          
        EndIf
        
        
        
      Case #WM_LBUTTONDOWN
        Debug "#WM_LBUTTONDOWN"
        If Gadget=#True
          Debug "Gadget ID = " + Str(ID)
       
        
        ;double clic gauche
        If *Pointer\time < LastLeftButtonClickTime + GetDoubleClickTime_()
          
          Debug "DOUBLE CLIC"
          Select ID
            Case 0
              Debug "DOUBLECLIC SUR EditorGadget ID=0" 
              
            Case 1
              Debug "DOUBLECLIC SUR ButtonGadget ID=1"
              
            Case 2
              Debug "DOUBLECLIC SUR TextGadget ID=2" 
              
          EndSelect          
          
        Else
          LastLeftButtonClickTime = *Pointer\time
        EndIf
      Else 
        Debug "sur Windows #Main"
      EndIf
      
      Case #WM_LBUTTONUP
        Debug "#WM_LBUTTONUP"
        If Gadget=#True
          Debug "Gadget ID = " + Str(ID)
        Else 
        Debug "sur Windows #Main"
      EndIf
        
        
      Case #WM_RBUTTONDOWN
        Debug "#WM_RBUTTONDOWN"
        If Gadget=#True
          Debug "Gadget ID = " + Str(ID)
        
        ;double clic droit
        ;         If *Pointer\time < LastLeftButtonClickTime + GetDoubleClickTime_()
        ;           
        ;             Debug "DOUBLE CLIC"
        ;             Select ID
        ;               Case 0
        ;                 Debug "DOUBLECLIC SUR EditorGadget 0" 
        ;                 
        ;               Case 1
        ;                 Debug "DOUBLECLIC SUR ButtonGadget 1"
        ;                 
        ;               Case 2
        ;                 Debug "DOUBLECLIC SUR TextGadget 2" 
        ;                 
        ;             EndSelect          
        ;             
        ;             Else
        ;                 LastLeftButtonClickTime = *Pointer\time
        ;               EndIf
        Else 
        Debug "sur Windows #Main"
      EndIf
        
      Case #WM_RBUTTONUP
        Debug "#WM_RBUTTONUP"
        If Gadget=#True
          Debug "Gadget ID = " + Str(ID)
        Else 
        Debug "sur Windows #Main"
      EndIf
        
        
      Case #WM_MBUTTONDOWN
        Debug "#WM_MBUTTONDOWN" 
        If Gadget=#True
          Debug "Gadget ID = " + Str(ID)
       
        ;double clic milieu
        ;         If *Pointer\time < LastLeftButtonClickTime + GetDoubleClickTime_()
        ;           
        ;             Debug "DOUBLE CLIC"
        ;             Select ID
        ;               Case 0
        ;                 Debug "DOUBLECLIC SUR EditorGadget 0" 
        ;                 
        ;               Case 1
        ;                 Debug "DOUBLECLIC SUR ButtonGadget 1"
        ;                 
        ;               Case 2
        ;                 Debug "DOUBLECLIC SUR TextGadget 2" 
        ;                 
        ;             EndSelect          
        ;             
        ;             Else
        ;                 LastLeftButtonClickTime = *Pointer\time
        ;               EndIf
        Else 
        Debug "sur Windows #Main"
      EndIf
        
      Case #WM_MBUTTONUP
        Debug "#WM_MBUTTONUP"
        If Gadget=#True
          Debug "Gadget ID = " + Str(ID)
        Else 
        Debug "sur Windows #Main"
      EndIf
        
        
      Case #WM_MOUSEWHEEL
        Debug "wheel"
        ;Debug *Pointer\mouseData>>16 ; = +/- 120 et jamais 0
        If *Pointer\mouseData >0
          Debug " en avant"
        Else
          Debug " en arrière"
        EndIf
        
    EndSelect
    
  EndIf
  
  
  ProcedureReturn CallNextHookEx_(HHOOKMouse, nCode, wParam, lParam)
EndProcedure



hWinMain=OpenWindow(#Main, 0, 0, 600, 600, "Mouse Hook", #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget |#PB_Window_ScreenCentered)

EditorGadget(0, 10, 10, 50, 50)
ButtonGadget(1, 10, 60, 60,30,"ok")
TextGadget(2,10,100,60,30,"texte")

HHOOKMouse = SetWindowsHookEx_(#WH_MOUSE_LL, @LowLevelMouseProc(), GetModuleHandle_(0), 0)

Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow

UnhookWindowsHookEx_(HHOOKLMouse)

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 23
; FirstLine = 7
; Folding = -
; EnableXP